typedef	void	*LIST_BOX;

typedef	void	(cdecl *SLCT_ITEM)( LIST_BOX *box, OBJECT *tree, struct _lbox_item *item, void *user_data, WORD obj_index, WORD last_state );
typedef	WORD	(cdecl *SET_ITEM)( LIST_BOX *box, OBJECT *tree, struct _lbox_item *item, WORD obj_index, void *user_data, GRECT *rect, WORD first );

typedef struct	_lbox_item
{
	struct _lbox_item *next;	/* Zeiger auf den nchsten Eintrag in der Liste */
	WORD	selected;				/* gibt an, ob das Objekt selektiert ist */

	WORD	data1;					/* Daten fr das Programm... */
	void	*data2;
	void	*data3;

} LBOX_ITEM;

#define	LBOX_VERT	1			/* Listbox mit vertikalem Slider */
#define	LBOX_AUTO	2			/* Auto-Scrolling */
#define	LBOX_AUTOSLCT	4		/* automatische Darstellung beim Auto-Scrolling */
#define	LBOX_REAL	8			/* Real-Time-Slider */
#define	LBOX_SNGL	16			/* nur ein anwhlbarer Eintrag */
#define	LBOX_SHFT	32			/* Mehrfachselektionen mit Shift */
#define	LBOX_TOGGLE	64			/* Status eines Eintrags bei Selektion wechseln */
#define	LBOX_2SLDRS	128		/* Listbox hat einen hor. und einen vertikalen Slider */

#define	lbox_get_visible \
			lbox_get_avis

#define	lbox_get_first \
			lbox_get_afirst
			
#define	lbox_set_slider \
			lbox_set_asldr

#define	lbox_scroll_to \
			lbox_ascroll_to
			
extern LIST_BOX	*lbox_create( OBJECT *tree, SLCT_ITEM slct, SET_ITEM set, LBOX_ITEM *items, WORD visible_a, WORD first_a,
										  WORD *ctrl_objs, WORD *objs, WORD flags, WORD pause_a, void *user_data, DIALOG *dialog,
										  WORD visible_b, WORD first_b, WORD entries_b, WORD pause_b );

extern void	lbox_update( LIST_BOX *box, GRECT *rect );
extern WORD	lbox_do( LIST_BOX *box, WORD obj );
extern WORD	lbox_delete( LIST_BOX *box );

extern WORD	lbox_cnt_items( LIST_BOX *box );
extern OBJECT	*lbox_get_tree( LIST_BOX *box );
extern WORD	lbox_get_avis( LIST_BOX *box );
extern void	*lbox_get_udata( LIST_BOX *box );
extern WORD	lbox_get_afirst( LIST_BOX *box );
extern WORD	lbox_get_slct_idx( LIST_BOX *box );
extern LBOX_ITEM	*lbox_get_items( LIST_BOX *box );
extern LBOX_ITEM	*lbox_get_item( LIST_BOX *box, WORD n );
extern LBOX_ITEM *lbox_get_slct_item( LIST_BOX *box );
extern WORD	lbox_get_idx( LBOX_ITEM *items, LBOX_ITEM *search );
extern WORD	lbox_get_bvis( LIST_BOX *box );
extern WORD	lbox_get_bentries( LIST_BOX *box );
extern WORD	lbox_get_bfirst( LIST_BOX *box );

extern void	lbox_set_asldr( LIST_BOX *box, WORD first, GRECT *rect );
extern void	lbox_set_items( LIST_BOX *box, LBOX_ITEM *items );
extern void	lbox_free_items( LIST_BOX *box );
extern void	lbox_free_list( LBOX_ITEM *items );
extern void	lbox_ascroll_to( LIST_BOX *box, WORD first, GRECT *box_rect, GRECT *slider_rect );
extern void	lbox_set_bsldr( LIST_BOX *box, WORD first, GRECT *rect );
extern void	lbox_set_bentries( LIST_BOX *box, WORD entries );
extern void	lbox_bscroll_to( LIST_BOX *box, WORD first, GRECT *box_rect, GRECT *slider_rect );


